ormolu-0.1.2.0: A formatter for Haskell source code

Safe Haskell | None
Language | Haskell2010

Ormolu.Printer.Meat.Common

Description

Rendering of commonly useful bits.

Synopsis

- data FamilyStyle
  - = Associated
  - | Free
- p_hsmodName :: ModuleName -> R ()
- p_ieWrappedName :: IEWrappedName RdrName -> R ()
- p_rdrName :: Located RdrName -> R ()
- doesNotNeedExtraParens :: RdrName -> Bool
- p_qualName :: ModuleName -> OccName -> R ()
- p_infixDefHelper :: Bool -> Bool -> R () -> [R ()] -> R ()
- p_hsDocString :: HaddockStyle -> Bool -> LHsDocString -> R ()
- p_hsDocName :: String -> R ()

# Documentation

data FamilyStyle Source #

Data and type family style.

Constructors

Associated | Declarations in type classes
Free | Top-level declarations

p_hsmodName :: ModuleName -> R () Source #

p_ieWrappedName :: IEWrappedName RdrName -> R () Source #

p_rdrName :: Located RdrName -> R () Source #

Render a ``Located` `RdrName``.

doesNotNeedExtraParens :: RdrName -> Bool Source #

Whether given name should not have parentheses around it. This is used to detect e.g. tuples for which annotations will indicate parentheses, but the parentheses are already part of the symbol, so no extra layer of parentheses should be added. It also detects the [] literal.

p_qualName :: ModuleName -> OccName -> R () Source #

p_infixDefHelper Source #

Arguments

:: Bool | Whether to format in infix style
-> Bool | Whether to bump indentation for arguments
-> R () | How to print the operator/name
-> [R ()] | How to print the arguments
-> R () |

A helper for formatting infix constructions in lhs of definitions.

p_hsDocString Source #

Arguments

:: HaddockStyle | Haddock style
-> Bool | Finish the doc string with a newline
-> LHsDocString | The doc string to render
-> R () |

Print a Haddock.

p_hsDocName :: String -> R () Source #

Print anchor of named doc section.